;//////////////////////////////////////////////////////////////////////////////
;/// Petezl 2005 //////////////////////////////////////////////////////////////
;/// Example of coloring text and background of a Static control in a window //
;//////////////////////////////////////////////////////////////////////////////

.386 
.model flat,stdcall 
option casemap:none 

include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\gdi32.inc 

includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\gdi32.lib 

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD 

.data 
ClassName   db "Petezl_WinClass",0 
AppName     db "Static Window",0 
StaticClass db "STATIC",0 
StaticID1   dd 2001
StaticID2   dd 2002
StaticText  db "Text in a Static, in a window",0

;// Define the colors
YellBrush   dd 0000ffffh
hyellBrush  dd 0
redText     dd 000000ffh

.data? 
hInstance HINSTANCE ? 
CommandLine LPSTR ? 
hwndStatic1 HANDLE ? 
hwndStatic2 HANDLE ? 

.code 
start: 
invoke GetModuleHandle, NULL 
mov hInstance,eax 
invoke GetCommandLine
mov CommandLine,eax 
invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT 
invoke ExitProcess,eax 

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 
mov wc.cbSize,SIZEOF WNDCLASSEX 
mov wc.style, CS_HREDRAW or CS_VREDRAW 
mov wc.lpfnWndProc, OFFSET WndProc 
mov wc.cbClsExtra,NULL 
mov wc.cbWndExtra,NULL 
push hInst 
pop wc.hInstance 
mov wc.hbrBackground,COLOR_BTNFACE+1 
mov wc.lpszMenuName, 0h 
mov wc.lpszClassName,OFFSET ClassName 
invoke LoadIcon,NULL,IDI_APPLICATION 
mov wc.hIcon,eax 
mov wc.hIconSm,eax 
invoke LoadCursor,NULL,IDC_ARROW 
mov wc.hCursor,eax 
invoke RegisterClassEx, addr wc 
;// WS_CLIPCHILDREN excludes the area occupied by child windows
;// when drawing occurs within the parent window.
invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName, \ 
ADDR AppName, WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\ 
CW_USEDEFAULT, CW_USEDEFAULT,\ 
370,320,NULL,NULL, hInst,NULL

mov hwnd,eax 
invoke ShowWindow, hwnd,SW_SHOWNORMAL 
invoke UpdateWindow, hwnd 
.WHILE TRUE 
invoke GetMessage, ADDR msg,NULL,0,0 
.BREAK .IF (!eax) 
invoke TranslateMessage, ADDR msg 
invoke DispatchMessage, ADDR msg 
.ENDW 
mov eax,msg.wParam 
ret 
WinMain endp
; 

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

.IF uMsg==WM_DESTROY 
               invoke DeleteObject, hyellBrush 
               invoke PostQuitMessage,NULL 

.elseif uMsg == WM_CREATE 

;// Create Static 1
               invoke CreateWindowEx, WS_EX_CLIENTEDGE, 
               ADDR StaticClass, NULL, WS_CHILD+WS_VISIBLE, \
               30,30,300,100, hWnd, StaticID1, hInstance, 0 
               mov hwndStatic1,eax 
;// Create Static 2
               invoke CreateWindowEx, WS_EX_CLIENTEDGE, 
               ADDR StaticClass, offset StaticText, WS_CHILD+WS_VISIBLE, \
               30,160,300,100, hWnd, StaticID2, hInstance, 0 
               mov hwndStatic2,eax 

               invoke CreateSolidBrush, YellBrush
               mov hyellBrush,eax 

.elseif uMsg == WM_CTLCOLORSTATIC 
                mov eax,lParam 
                
                    .if     eax == hwndStatic1 
                            invoke GetStockObject, BLACK_BRUSH 
                            ret 
                    .elseif   eax == hwndStatic2 

                            invoke SetBkMode, wParam, TRANSPARENT 
                            invoke SetTextColor, wParam, redText
                            mov eax, hyellBrush ; background brush color, equivalent of SelectObject
                            ret
                    .endif 
.else 
invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
ret 
.endif 
xor eax,eax 
ret 
WndProc endp

end start 
